您的位置:首页 > 其它

Codeforces Round #358 (Div. 2) -- D. Alyona and Strings (DP)

2016-07-09 12:29 323 查看
[align=center]D. Alyona and Strings[/align]

time limit per test
2 seconds

memory limit per test
256 megabytes

input
standard input

output
standard output

After returned from forest, Alyona started reading a book. She noticed stringss andt, lengths of which aren andm
respectively. As usual, reading bored Alyona and she decided to pay her attention to stringss andt, which she considered very similar.

Alyona has her favourite positive integer k and because she is too small,k does not exceed10. The girl wants now to choosek
disjoint non-empty substrings of strings such that these strings appear as disjoint substrings of stringt and in the same order as they do in strings.
She is also interested in that their length is maximum possible among all variants.

Formally, Alyona wants to find a sequence of k non-empty stringsp1, p2, p3, ..., pk
satisfying following conditions:

s can be represented as concatenation
a1p1a2p2...akpkak + 1,
wherea1, a2, ..., ak + 1 is a sequence of arbitrary strings (some of them may be possibly empty);
t can be represented as concatenation
b1p1b2p2...bkpkbk + 1,
whereb1, b2, ..., bk + 1 is a sequence of arbitrary strings (some of them may be possibly empty);
sum of the lengths of strings in sequence is maximum possible.
Please help Alyona solve this complicated problem and find at least the sum of the lengths of the strings in a desired sequence.

A substring of a string is a subsequence of consecutive characters of the string.

Input
In the first line of the input three integers n,m,k (1 ≤ n, m ≤ 1000,1 ≤ k ≤ 10)
are given — the length of the strings, the length of the stringt and Alyona's favourite number respectively.

The second line of the input contains string s, consisting of lowercase English letters.

The third line of the input contains string t, consisting of lowercase English letters.

Output
In the only line print the only non-negative integer — the sum of the lengths of the strings in a desired sequence.

It is guaranteed, that at least one desired sequence exists.

Examples

Input
3 2 2
abc
ab


Output
2


Input
9 12 4
bbaaababb
abbbabbaaaba


Output
7


Note
The following image describes the answer for the second sample case:

大体题意:

给你两个字符串长度分别为n和m,和k。求出一个新字符串的最大长度,使得这个字符串都属于s,t,并且出现的顺序一致。最多k段。(可能表述不清,具体看看英文吧!= = !)

思路:

借鉴的学长的博客!

令dp[i][j][k][0]表示s字符串当前字符是i, t字符串当前字符是j,组成k段且连续下去的 值!(就是第k段还没完事)

dp[i][j][k][1]表示t字符串当前字符是i,t字符串是j 组成k 段不连续下去的值!(第k段已完成!)

那么当s[i] == t[j]时,肯定能连续的!

dp[i][j][k][0] = max(dp[i-1][j-1][k-1][1],dp[i-1][j-1][k][0]) + 1,表示前面的 组成k-1段中断和前面组成k段继续连续!

剩下的 无论相等还是不想等   dp[i][j][k][1] 都有来自  dp[i-1][j][k][1]和dp[i][j-1][k][1]

dp[i][j][k][1] = max{   dp[i-1][j][k][1],  dp[i][j-1][k][1] ,    dp[i-1][j-1][k][1] , dp[i][j][k][0] } ;

如果两个字符相等  就比较dp[i][j][k][0]  , dp[i-1][j][k][1]和dp[i][j-1][k][1](因为能连续嘛!)

如果不相等 就比较    dp[i-1][j][k][1],  dp[i][j-1][k][1] ,    dp[i-1][j-1][k][1] ,  因为不相等 肯定不能连续!

#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;
const int maxn = 1000 + 10;
int dp[maxn][maxn][12][2];
char s[maxn],t[maxn];
int main(){
int n,m,kk;
scanf("%d %d %d",&n,&m,&kk);
scanf("%s",s+1);
scanf("%s",t+1);
for (int i = 1; i <= n; ++i){
for (int j = 1; j <= m; ++j){
if (s[i] == t[j]){
for (int k = 1; k <= kk; ++k){
dp[i][j][k][0] = max(dp[i-1][j-1][k-1][1],dp[i-1][j-1][k][0]) + 1;
dp[i][j][k][1] = max(dp[i][j][k][1],max(dp[i][j][k][0],max(dp[i-1][j][k][1],dp[i][j-1][k][1])));
}
}
else{
for (int k = 1; k <= kk; ++k)
dp[i][j][k][1] = max(max(dp[i-1][j][k][1],dp[i][j][k][1]),max(dp[i][j-1][k][1],dp[i-1][j-1][k][1]));
}

}

}
printf("%d\n",dp
[m][kk][1]);

return 0;
}


                                            
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: